/*!
 ______ _____   _______ _______ _______ _______ ______ _______ 
|   __ \     |_|    ___|_     _|   |   |       |   __ \   _   |
|    __/       |    ___| |   | |       |   -   |      <       |
|___|  |_______|_______| |___| |___|___|_______|___|__|___|___|

P L E T H O R A T H E M E S . C O M 				     (c) 2014
                        
Theme Name: CleanStart
This file contains Flexslider settings for Featured Media Slider. Loaded only when is present on page

*/

//===============Jquery to perform on DOM Ready=========================================================

jQuery(document).ready(function() {
			  
"use strict";			  
    			  
    // FLEXSLIDER settings & init for the homepage slider

    // GET SLIDER SETTINGS
    var slider_options = plethora_slider.slider_options;

    var animationloop = plethoraUtils.checkBool( slider_options['animationloop'] );
    var slideshow     = plethoraUtils.checkBool( slider_options['slideshow'] );
    var randomize     = plethoraUtils.checkBool( slider_options['randomize'] );
    var pauseonaction = plethoraUtils.checkBool( slider_options['pauseonaction'] );
    var pauseonhover  = plethoraUtils.checkBool( slider_options['pauseonhover'] );
    var showbullets   = plethoraUtils.checkBool( slider_options['showbullets'] );
    var showarrows    = plethoraUtils.checkBool( slider_options['showarrows'] );

    jQuery('#main_flexslider').flexslider({
    namespace: "flex-",                                     //{NEW} String: Prefix string attached to the class of every element generated by the plugin
    selector: ".slides > li",                               //{NEW} Selector: Must match a simple pattern. '{container} > {slide}' -- Ignore pattern at your own peril
    animation: "slide",                                     //String: Select your animation type, "fade" or "slide"
    easing: "swing",                                        //{NEW} String: Determines easing method for jQuery transitions. jQuery easing plugin is supported!
    direction: slider_options['direction'],                 //String: Select the sliding direction, "horizontal" or "vertical"
    reverse: false,                                         //{NEW} Boolean: Reverse the animation direction
    animationLoop: animationloop,                            //Boolean: Should the animation loop? If false, directionNav will received "disable" classes at either end
    smoothHeight: false,                                    //{NEW} Boolean: Allow height of the slider to animate smoothly in horizontal mode
    startAt: 0,                                             //Integer: The slide that the slider should start on. Array notation (0 = first slide)
    slideshow: slideshow,                                    //Boolean: Animate slider automatically
    slideshowSpeed: slider_options['slideshowspeed']*1000,  //Integer: Set the speed of the slideshow cycling, in milliseconds
    animationSpeed: slider_options['animationspeed'],       //Integer: Set the speed of animations, in milliseconds
    initDelay: 0,                                           //{NEW} Integer: Set an initialization delay, in milliseconds
    randomize: randomize,                                   //Boolean: Randomize slide order
     
    // USABILITY FEATURES
    pauseOnAction: pauseonaction,                           //Boolean: Pause the slideshow when interacting with control elements, highly recommended.
    pauseOnHover: pauseonhover,                             //Boolean: Pause the slideshow when hovering over slider, then resume when no longer hovering
    useCSS: true,                                           //{NEW} Boolean: Slider will use CSS3 transitions if available
    touch: true,                                            //{NEW} Boolean: Allow touch swipe navigation of the slider on touch-enabled devices
    video: false,                                           //{NEW} Boolean: If using video in the slider, will prevent CSS3 3D Transforms to avoid graphical glitches
     
    // PRIMARY CONTROLS

    controlNav: showbullets,                                //Boolean: Create navigation for paging control of each clide? Note: Leave true for manualControls usage
    directionNav: showarrows,                               //Boolean: Create navigation for previous/next navigation? (true/false)
    prevText: "Previous",                                   //String: Set the text for the "previous" directionNav item
    nextText: "Next",                                       //String: Set the text for the "next" directionNav item
     
    // CALLBACK API
    start: function(){
    	//jQuery('.flex-active-slide .container .carousel-caption').addClass('show');
    	},                                                 //Callback: function(slider) - Fires when the slider loads the first slide
    before: function(){
    	jQuery('.flex-active-slide .container .carousel-caption').removeClass('show');
    	jQuery(".flexslider .carousel-caption").addClass("wait_for_photo_load").hide();
    	},                                                 //Callback: function(slider) - Fires asynchronously with each slider animation
    after: function(slider){
    	jQuery('.flex-active-slide .container .carousel-caption').addClass('show');
    	jQuery(".flexslider .carousel-caption.show").removeClass("wait_for_photo_load").show();
    	},                                                 //Callback: function(slider) - Fires after each slider animation completes
    end: function(){},                                     //Callback: function(slider) - Fires when the slider reaches the last slide (asynchronous)
    added: function(){},                                   //{NEW} Callback: function(slider) - Fires after a slide is added
    removed: function(){}                                  //{NEW} Callback: function(slider) - Fires after a slide is removed

    });

    //Refrain the flexslider carousel-caption elements from performing their animation untill the photo loads 
    jQuery(".flexslider .carousel-caption").addClass("wait_for_photo_load").hide();

});
//END==================Jquery to perform on DOM Ready=============================================================