<?php
/*
 ______ _____   _______ _______ _______ _______ ______ _______ 
|   __ \     |_|    ___|_     _|   |   |       |   __ \   _   |
|    __/       |    ___| |   | |       |   -   |      <       |
|___|  |_______|_______| |___| |___|___|_______|___|__|___|___|

P L E T H O R A T H E M E S . C O M 				   (c) 2014

Description: WP Less ( Please reference to this on https://github.com/oyejorge/less.php - DO NOT USE THE OFFICIAL RELEASE )
Module Customization: /assets/wp-less/lib/vendor/lessphp/less.inc.php ( lines 125-127 - raising memory limit to 128M only on recompiling )
Version: 1.0

*/

if ( ! defined( 'ABSPATH' ) ) exit; // NO DIRECT ACCESS 

	class Plethora_Module_Wpless{

		public function __construct() {


			// Load WP-LESS, if not already loaded by other plugin

			if (!class_exists('WPLessPlugin')) {

				define('WP_LESS_COMPILATION', 'deep');

				require_once THEME_ASSETS_DIR .'/wp-less/lib/Plugin.class.php';

				// The file is empty...just used for core directory reference
				$WPLessPlugin = WPPluginToolkitPlugin::create('WPLess', THEME_ASSETS_DIR .'/wp-less/bootstrap-for-theme.php', 'WPLessPlugin');

				global $cleanstart_options;
	
				$wp_skin_color       = ( isset( $cleanstart_options['skin-color']) ) ? $cleanstart_options['skin-color'] : "#428BCA";
				$wp_body_bg          = ( isset( $cleanstart_options['body-backround'] ) ) ? $cleanstart_options['body-backround'] : "#EFEFEF";
				$wp_font_alternative = ( isset( $cleanstart_options['font-headers']['font-family'] ) ) ? $cleanstart_options['font-headers']['font-family'] : "Raleway";
				$wp_font_sansserif   = ( isset( $cleanstart_options['font-body']['font-family'] ) ) ? $cleanstart_options['font-body']['font-family'] : "Open Sans";
				$wp_slider_height    = ( isset( $cleanstart_options[ PLETHORA_META_PREFIX .'header-slider-dimensions']['height'] ) ) ? $cleanstart_options[ PLETHORA_META_PREFIX .'header-slider-dimensions']['height'] : "580px";

			    $WPLessPlugin->setVariables(array(
					'wp-skin-color'              => $wp_skin_color, 				// '#A59C78',
					'wp-body-bg'                 => $wp_body_bg, 					// '#EFEFEF',
					'wp-font-family-alternative' => '"'. $wp_font_alternative .'"', // 'Raleway'
					'wp-font-family-sans-serif'  => '"'. $wp_font_sansserif .'"', 	// 'Open Sans'
					'wp-slider-height'           => $wp_slider_height, 				// '580px'
			    ));

				add_action('init', array($this, 'enqueue_less'));

				// READY and WORKING
				add_action('after_setup_theme', array($WPLessPlugin, 'install'));

				// NOT WORKING
				//@see http://core.trac.wordpress.org/ticket/14955
				add_action('uninstall_theme', array($WPLessPlugin, 'uninstall'));

				$WPLessPlugin->dispatch();
			}

		}

       /** 
       * Enqueues less files
       *
       * @return array
       * @since 1.0
       *
       */
		function enqueue_less() {

			if ( !is_admin() ) { 

			    wp_enqueue_style('style-less', get_template_directory_uri().'/assets/less/style.less');

			}
		}	

       /** 
       * Returns feature information for several uses by Plethora Core (theme options etc.)
       *
       * @return array
       * @since 1.0
       *
       */
       public static function get_feature_options() {

          $feature_options = array ( 
				'switchable'       => false,
				'options_title'    => 'WP Less Module',
				'options_subtitle' => 'Activate/deactivate WP Less module',
				'options_desc'     => 'On deactivation, all settings related to this feature will be removed. However, they will not be deleted permanently.',
            );
          
          return $feature_options;
       }
	}