<?php
/*
 ______ _____   _______ _______ _______ _______ ______ _______ 
|   __ \     |_|    ___|_     _|   |   |       |   __ \   _   |
|    __/       |    ___| |   | |       |   -   |      <       |
|___|  |_______|_______| |___| |___|___|_______|___|__|___|___|

P L E T H O R A T H E M E S . C O M 				   (c) 2013

File Description: Portfolio Grid shortcode

*/

if ( ! defined( 'ABSPATH' ) ) exit; // NO DIRECT ACCESS 

if ( class_exists('Plethora_Shortcode') && !class_exists('Plethora_Shortcode_Portfoliogrid') && class_exists('Plethora_Posttype_Portfolio') ):

	/**
	 * @package Plethora Base
	 */

	class Plethora_Shortcode_Portfoliogrid extends Plethora_Shortcode { 

    	 function __construct() {

          // REGISTER SHORTCODE
 
              // Hook shortcode registration on init
              $this->add('sc_portfoliogrid', array($this,'content'));

          // MAP PARAMETERS TO UI PANELS ( we use the params() method to get defined parameters )

              // Add shortcode parameters to shortcodes button menu.
              $this->map_panel( $this->params() );

              // Add shortcode parameters to Visual Composer UI 
              $this->map_vcpanel( $this->params() );

          // ADD SCRIPTS 
              // Prepare array for script registration according to wp_register_script usage. 
              if (!is_admin()) {
                $this->add_script( array(
                  array(
                  'handle'    => 'isotope-plethora', 
                  'src'       => THEME_ASSETS_URI . '/js/isotope/jquery.isotope.min.js', 
                  'deps'      => array( 'jquery' ), 
                  'ver'       => '1.0', 
                  'in_footer' => true
                  ),
                ));
              }

              // Note: scripts are loaded only when the shortcode is visible in frontend. You may add more than one

          // ADD STYLES 
              if (!is_admin()) {
              // Prepare shortcode related styles array according to wp_register_style usage (may add more than one)
                $this->add_style( array(
                  array(
                  'handle'    => 'isotope-plethora', 
                  'src'       => THEME_ASSETS_URI . '/js/isotope/css/style.css', 
                  'deps'      => array(),  
                  'ver'       => false,    
                  'media'     => 'all'     
                  ),
                ));           
              }

    	 }

       /** 
       * Returns feature information for several uses by Plethora Core (theme options etc.)
       *
       * @return array
       * @since 1.0
       *
       */
       public function get_feature_options() {

          $feature_options = array ( 
              'switchable'       => true,
              'options_title'    => 'Portfolio Grid shortcode',
              'options_required' => array('posttype-portfolio-status','=',array('1')),  // Required Features (similar with Plethora Redux required field)
              'options_subtitle' => 'Activate/deactivate portfolio grid shortcode',
              'options_desc'     => 'On deactivation, all settings related to this feature will be removed. However, they will not be deleted permanently.',
              'version'          => '1.0'
            );
          
          return $feature_options;
       }

       /** 
       * Returns shortcode settings (compatible with Visual composer)
       *
       * @return array
       * @since 1.0
       *
       */
       public function params() {

          $sc_settings =  array(
              "base"              => $this->shortcode_slug,
              "name"              => __("Portfolio Grid", 'cleanstart'),
              "description"       => __('Build a custom portfolio grid', 'cleanstart'),
              "class"             => "",
              "weight"            => 1,
              "category"          => 'Plethora Shortcodes',
              "button_menu"       => 'Loops',    // used exclusively in TinyMCE button menu
              "admin_enqueue_css" => THEME_CORE_ASSETS_URI .'/admin-shortcodes.css',
              "icon"              => THEME_CORE_ASSETS_URI . '/icons/plethora_shortcodes-32x32.png', 
              "params"            => array(
                  array(
                      "param_name"    => "layout",
                      "type"          => "dropdown",
                      "heading"       => __("Grid layout", 'cleanstart'),
                      "value"         => array(__('Classic', 'cleanstart') =>'classic', __('Masonry', 'cleanstart') =>'masonry'),
                      "btn_menu_value"=> "classic",
                      "description"   => __("Select the desired post grid layout", 'cleanstart')
                  ),
                  array(
                      "param_name"    => "layout_columns",
                      "type"          => "dropdown",
                      "heading"       => __("Grid columns", 'cleanstart'),
                      "value"         => array('2' => '2', '3' => '3', '4' => '4'),
                      "btn_menu_value"=> "3",
                      "description"   => __("Set the number of grid columns you need", 'cleanstart')
                  ),
                  array(
                      "param_name"    => "results",
                      "type"          => "dropdown",
                      "heading"       => __('Maximum post results', 'cleanstart'),
                      "value"         => array(
                                        '1' => '1', 
                                        '2' => '2', 
                                        '3' => '3', 
                                        '4' => '4', 
                                        '5' => '5', 
                                        '6' => '6', 
                                        '7' => '7', 
                                        '8' => '8', 
                                        '9' => '9', 
                                        '10' => '10', 
                                        '11' => '11', 
                                        '12' => '12', 
                                        '13' => '13', 
                                        '14' => '14', 
                                        '15' => '15', 
                                        '16' => '16', 
                                        '17' => '17', 
                                        '18' => '18', 
                                        '19' => '19', 
                                        '20' => '20', 
                                        '21' => '21', 
                                        '22' => '22', 
                                        '23' => '23', 
                                        '24' => '24', 
                                        ),
                      "btn_menu_value"=> "12",
                      "description"   => __("Set the maximum results in grid", 'cleanstart')
                  ),
                  array(
                      "param_name"    => "orderby",
                      "type"          => "dropdown",
                      "heading"       => __('Order by', 'cleanstart'),
                      "value"         => array(__('Date', 'cleanstart') =>'date', __('Random', 'cleanstart')  => 'random'),
                      "btn_menu_value"=> "Date",
                      "description"   => __("Select order", 'cleanstart')
                  ),
                  array(
                      "param_name"    => "category_filters",
                      "type"          => "dropdown",
                      "heading"       => __('Project types menu', 'cleanstart'),
                      "value"         => array( __('Yes', 'cleanstart') =>'yes', __('No', 'cleanstart')  => 'no'),
                      "btn_menu_value"=> __('Yes', 'cleanstart') ,
                      "description"   => __("Display the Project types menu", 'cleanstart')
                  ),
                  array(
                      "param_name"    => "exclude_categories",
                      "type"          => "checkbox",
                      "heading"       => __("Exclude project types", 'cleanstart'),
                      "value"         => Plethora_Helper::array_categories(array('taxonomy'=>'project-type')),
                      "btn_menu_value"=> Plethora_Helper::array_categories(array('taxonomy'=>'project-type')),
                      "description"   => __("Check every project type that you don't want to be included in results", 'cleanstart')
                  )
              )
          );

          return $sc_settings;
       }


       /** 
       * Returns shortcode content
       *
       * @return array
       * @since 1.0
       *
       */
       public function content( $atts, $content = null ) {

          $this->add_script = true; // VERY IMPORTANT! This triggers loading related scripts on footer
          $portfoliogrid_id = mt_rand( 1,5000 ); // VERY IMPORTANT! This generates a unique id for javascript inits

          extract( shortcode_atts( array( 
            'layout'             => 'classic',
            'layout_columns'     => '3',
            'results'            => '9',
            'orderby'            => 'date',
            'category_filters'   => 'yes',
            'exclude_categories' => ''
            ), $atts ) );

          
          // Set layout class value
          $val_layout = ($layout == 'masonry') ? 'portfolio_masonry' : 'portfolio_strict';
          // Set orderby value
          $val_orderby = ( $orderby == 'Random') ? 'rand' : 'date';
          // Set columns valueS
          switch ( $layout_columns ) {
              case '2':
                $val_cols = '6';
                $thumbsize = 'large';
                  break;
              case '3':
                $val_cols = '4';
                $thumbsize = 'large';
                  break;
              case '4':
                $val_cols = '3';
                $thumbsize = 'large';
                  break;
              default:
                $val_cols = '3';
                $thumbsize = 'large';
          }

          $exclude = array();
          if ( !empty($exclude_categories) ) { 
            $exclude = explode(",", $exclude_categories);
          }
          // Results query arguments
          $args = array(
                  'numberposts'      => $results,
                  'offset'           => 0,
                  'category'         => '',
                  'orderby'          => $val_orderby,
                  'order'            => 'DESC',
                  'post_type'        => 'portfolio',
                  'post_status'      => 'publish',
          );

          // Results query
          // $posts = get_posts($args);

          $args = array(
            'posts_per_page'      =>$results,
            'ignore_sticky_posts' =>0,
            'post_type'           => 'portfolio',
            'orderby'             => $val_orderby,
            'tax_query' => array(
                        array(
                          'taxonomy' => 'project-type',
                          'field'    => 'id',
                          'terms'    => $exclude,
                          'operator' => 'NOT IN'                          
                        )
            )        
          );
          $post_query = new WP_Query($args);


          // At first, we assign the post results to a variable. We do this first, in order to get the 
          // specific categories present (avoiding this way, to show an empty category tab)
          if( $post_query->have_posts() ) {

            // Set the array that will contain all the resulted posts categories
            $categories = array();

            // The loop
            $section_posts = '';
            while ($post_query->have_posts()) { 
            $post_query->the_post();

                // Get the post's categories (use wp_get_object_terms for custom post type)
                $post_categories = wp_get_object_terms( get_the_ID(), 'project-type' );

                $post_cat_classes = '';
                $post_cat_names = '';
                if (!empty($post_categories) && !is_wp_error( $post_categories ) ) { 

                   // Set the variable that will contain all the categiry selector classes
                   foreach ($post_categories as $category) { 

                      $categories[] = $category->name;
                      $post_cat_classes .= strtolower(sanitize_html_class( $category->name )) .' ';
                      $post_cat_names .= $category->name .' ';

                    }
                } 

                // Prepare posts section
                if ($val_layout == 'portfolio_strict') { 

                    $thumb_url = wp_get_attachment_image_src( get_post_thumbnail_id( get_the_ID() ),  $thumbsize) ;

                    $section_posts .= '<div class="'. $post_cat_classes .'col-xs-12 col-sm-6 col-md-'. $val_cols .' col-lg-'. $val_cols .'">'."\n";
                    $section_posts .= '     <div class="portfolio_item">'."\n"; 
                    $section_posts .= '       <a href="'. get_permalink() .'">'."\n";
                    $section_posts .= '          <figure style="background-image:url('. esc_url( $thumb_url[0] ) .')">'."\n";
                    $section_posts .= '               <figcaption>'."\n";
                    $section_posts .= '                 <div class="portfolio_description">'."\n";
                    $section_posts .= '                    <h3>'. get_the_title()  .'</h3>'."\n";
                    $section_posts .= '                    <span class="cross"></span>'."\n";
                    $section_posts .= '                    <p>'. $post_cat_names .'</p>'."\n";
                    $section_posts .= '                 </div>'."\n";
                    $section_posts .= '               </figcaption>'."\n";
                    $section_posts .= '          </figure>'."\n";
                    $section_posts .= '       </a>'."\n";
                    $section_posts .= '      </div>'."\n";
                    $section_posts .= '</div>'."\n";

                } else { 

                    $thumb_url = wp_get_attachment_image_src( get_post_thumbnail_id( get_the_ID() ),  $thumbsize) ;
                    
                    $section_posts .= '          <div class="'. $post_cat_classes .'col-sm-'. $val_cols .' col-md-'. $val_cols .'">'."\n";
                    $section_posts .= '             <div class="portfolio_item">'."\n";
                    $section_posts .= '               <a href="'. get_permalink() .'">'."\n";
                    $section_posts .= '                   <img src="'. esc_url( $thumb_url[0] ) .'" alt="'. esc_attr( get_the_title() ) .'" />'."\n";
                    $section_posts .= '                   <div class="overlay">'."\n";
                    $section_posts .= '                      <div class="desc">'."\n";
                    $section_posts .= '                         <h3>'. get_the_title()  .'</h3>'."\n";
                    $section_posts .= '                         <span class="cross"></span>'."\n";
                    $section_posts .= '                         <p>'. $post_cat_names .'</p>'."\n";
                    $section_posts .= '                      </div>'."\n";
                    $section_posts .= '                   </div>'."\n";
                    $section_posts .= '               </a>'."\n";
                    $section_posts .= '             </div>'."\n";
                    $section_posts .= '          </div>'."\n";
                }
            }



          } else {

            return;

          }
          
          $section_filters = "";

          if (!empty($categories)) { 

            $res_categories   = array_unique($categories); // get the unique categories found in results
            $categories       = array_diff($res_categories, $exclude); // remove excluded categories
            $section_filters .= '     <ul class="portfolio_filters" id="filt_'. $portfoliogrid_id  .'">'."\n";
            $section_filters .= '          <li><a href="#" data-filter="*">show all</a></li>'."\n";
            foreach ($categories as $categorykey=>$categoryname) { 
              $section_filters  .= '          <li><a href="#" data-filter=".'. esc_attr(strtolower(sanitize_html_class( $categoryname ))) .'">'. $categoryname .'</a></li>'."\n";
            }
            $section_filters  .= '     </ul>'."\n";
          }

          $initscript = '<script>';
            // cache container
          $initscript .= 'jQuery(window).load(function() {'."\n";
          $initscript .= '"use strict"; '."\n";
          $initscript .= '  var container = jQuery(\'#cont_'. $portfoliogrid_id  .'\'); '."\n";
            // initialize isotope
          $initscript .= '  container.isotope({ '."\n";
          $initscript .= '  }); ';
          $initscript .= '  jQuery(\'#filt_'. $portfoliogrid_id  .' a[data-filter="*"]\').addClass(\'active\'); '."\n";
            // filter items when filter link is clicked
          $initscript .= '  jQuery(\'#filt_'. $portfoliogrid_id  .' a\').click(function(){ '."\n";
          $initscript .= '    jQuery(\'#filt_'. $portfoliogrid_id  .' a\').removeClass(\'active\'); '."\n";
          $initscript .= '    jQuery(this).addClass(\'active\'); '."\n";
          $initscript .= '    var selector = jQuery(this).attr(\'data-filter\'); '."\n";
          $initscript .= '    container.isotope({ filter: selector }); '."\n";
          $initscript .= '    return false; '."\n";
          $initscript .= '  }); '."\n";
          $initscript .= '}); '."\n";
          $initscript .= '//used for window resize'."\n";
          $initscript .= 'jQuery(window).resize(function() {'."\n";
          $initscript .= '"use strict";'."\n";
          $initscript .= 'var container = jQuery(\'#cont_'. $portfoliogrid_id  .'\');'."\n";
          $initscript .= 'container.isotope({ });'."\n";
          $initscript .= '});'."\n";
          $initscript .= '</script>';

          $return = '';
          
          // Final HTML composing
          if ($val_layout == 'portfolio_strict') { 

            $return  = '<div class="portfolio_strict">'."\n";
            if ($category_filters == 'yes') { $return .= $section_filters; } 
            $return .= '                    <div class="row isotope_portfolio_container" id="cont_'. $portfoliogrid_id  .'">'."\n";
            $return .= $section_posts;
            $return .= '                    </div>'."\n";
            $return .= '</div>'."\n";
            $return .= $initscript;

          } else { 

            if ($category_filters == 'yes') { 
              $return  = '<div>';
              $return .= $section_filters; 
              $return .= '</div>';
            } 
            $return .= '<div class="portfolio_masonry">';
            $return .= '  <div class="row isotope_portfolio_container" id="cont_'. $portfoliogrid_id  .'">'."\n";
            $return .= $section_posts;
            $return .= '  </div>'."\n";
            $return .= '</div>'."\n";
            $return .= $initscript;

          }

          wp_reset_query();

          return $return ;

       }

	}
	
 endif;