<?php
/*
 ______ _____   _______ _______ _______ _______ ______ _______ 
|   __ \     |_|    ___|_     _|   |   |       |   __ \   _   |
|    __/       |    ___| |   | |       |   -   |      <       |
|___|  |_______|_______| |___| |___|___|_______|___|__|___|___|

P L E T H O R A T H E M E S . C O M 				   (c) 2013

File Description: Inner Row shortcode

*/

if ( ! defined( 'ABSPATH' ) ) exit; // NO DIRECT ACCESS 


if ( class_exists('Plethora_Shortcode') && !class_exists('Plethora_Shortcode_Vcrowinner') ):

	/**
	 * @package Plethora
	 */

	class Plethora_Shortcode_Vcrowinner extends Plethora_Shortcode { 

    	 function __construct() {

          // REGISTER SHORTCODE
 
              // Hook shortcode registration on init
              $this->add('vc_row_inner', array($this,'content'));

          // MAP PARAMETERS TO UI PANELS ( we use the params() method to get defined parameters )

            if ( is_admin() && function_exists('vc_remove_element') ) { 
              
              vc_remove_element( 'vc_row_inner' );
              // Add shortcode parameters to Visual Composer UI 
              $this->map_vcpanel( $this->params() );

            }

    	 }

       /** 
       * Returns shortcode content
       *
       * @return array
       * @since 1.0
       *
       */
       public function params() {

          $sc_settings =  array(
              "base"          => $this->shortcode_slug,
              "name"          => __("Row Inner", 'cleanstart'),
              "description"   => __('Create an nested row to add content', 'cleanstart'),
              "class"         => '',
              "weight"        => 1,
              "icon"          => "icon-wpb-row",
              'is_container'            => true,
              'show_settings_on_create' => false,
              'content_element'         => false,
              'weight'                  => 999,
              'js_view'                 => 'VcRowView',
              "params"        => array(
                    array(
                        "param_name"    => "extra_classes",
                        "type"          => "textfield",
                        "heading"       => __("Additional Classes", 'cleanstart'),
                        "description"   => __("Enter additional class name(s) for inner row ( separate with space )", 'cleanstart'),
                        "admin_label"   => false, 
                    ),


              )
          );

          return $sc_settings;
       }


       /** 
       * Returns shortcode content
       *
       * @return array
       * @since 1.0
       *
       */
       public function content( $atts, $content = null ) {

            extract( shortcode_atts( array( 
              'add_classes'         => '',
              ), $atts ) );

            $output .= '   <div class="row">';

            if( !empty( $content ) ) {
                $output .= do_shortcode( $content );
            }
            $output .= '    </div>';

            return $output;
       }


       /** 
       * Returns feature information for several uses by Plethora Core (theme options etc.)
       *
       * @return array
       * @since 1.0
       *
       */
       public function get_feature_options() {

          $feature_options = array (  
              'switchable'    => false, // this should be false...we don't want to make VC unusable!
              'options_title' => 'Inner Row Shortcode',
            );
          
          return $feature_options;
       }


	}
	
 endif;