jQuery(document).ready(function () {

    //Get Shortcodes from JSON


    function getValues(editor) {
        var shortcodes = jQuery.parseJSON(plethora_shortcode.params);
        var values = [];
        
        jQuery.each(shortcodes, function (key, obj) {
            val = obj[0];

            // Get all shortcode values
            sc_slug = val.base;
            sc_name = val.name;
            sc_description = val.description;
            sc_params = val.params;

            //Attribute
            var attr = [];

            //Input-Fields (shortcode form)
            var body = [];

            //Description
            body.push({
                type: 'label',
                name: 'description',
                text: sc_description,
                style: '',
            });

            // Parameter fields
            var params;
            if (typeof sc_params !== 'undefined') {
                params = true;
            } else {
                params = false;
            }

            //Load Input-Fields
            if (params) {

                
                raw_html_params = [];               // This is a raw textarea fields index array. Will be used later for the Base64 encoding procedure 
                exploded_textarea_params = [];       // This is a exploded textarea fields index array. Will be used later for exploding values in array 

                jQuery.each(sc_params, function (key, val) {


                    // Text input field
                    if (val.type == 'textfield') {

                        body.push({
                            type: 'textbox',
                            multiline: false,
                            value: val.btn_menu_value,
                            name: val.param_name,
                            label: val.heading
                        });


                    // Textarea field
                 } else if (val.type == 'textarea' || val.type == 'textarea_html' ) {

                        body.push({
                            type: 'textbox',
                            multiline: true,
                            minHeight: 100,
                            value: val.btn_menu_value,
                            name: val.param_name,
                            label: val.heading
                        });

                    // Select field
                  } else if (val.type == 'dropdown') {
                        
                        // get select options in a variable
                        var options_select = [];
                        var c = 0;
                        var onPostRenderValue = '';
                        jQuery.each(val.value, function (option_key, option_val) {
                            options_select.push({
                                text: option_key,
                                value: option_val
                            });
                            c = c + 1;
                            if ( c==1 ) { selectedFirstValue = option_val; } // if no value is preselected, then auto select first value ( otherwise no selection inserted in editor if the control is not touched!)
                        });
                        // get default selected option in a variable
                        if ( typeof val.btn_menu_value !== 'undefined' && val.btn_menu_value !== '' ) { 

                           var onPostRenderValue = val.btn_menu_value;

                        } else { 

                           var onPostRenderValue = selectedFirstValue;

                        }

                        body.push({
                            type: 'listbox',
                            name: val.param_name,
                            label: val.heading,
                            'values': options_select,
                            onPostRender: function() { this.value(onPostRenderValue); }
                        });

                  
                  } else if (val.type == 'dropdown_icons') {

                        body.push({
                            type: 'textbox',
                            multiline: false,
                            value: val.btn_menu_value,
                            name: val.param_name,
                            label: val.heading
                        });
                    

                  } else if (val.type == 'checkbox') {

                        body.push({
                            type: 'label',
                            name: 'label',
                            text: val.heading
                        });
                        jQuery.each(val.value, function (option_key, option_val) {
                            body.push({
                                type: 'checkbox',
                                name: val.param_name,
                                text: option_key,
                                value: option_val,
                                checked: true
                            });
                        });


                  } else if (val.type == 'attach_image') {

                        body.push({
                            type: 'textbox',
                            multiline: false,
                            value: val.btn_menu_value,
                            name: val.param_name,
                            label: val.heading
                        });


                  } else if (val.type == 'attach_images') {

                    exploded_textarea_params.push(val.param_name) // add it to the array converted fields parameter

                        body.push({
                            type: 'textbox',
                            multiline: true,
                            minHeight: 100,
                            value: val.btn_menu_value,
                            name: val.param_name,
                            label: val.heading
                        });


                  } else if (val.type == 'vc_link') {

                        body.push({
                            type: 'textbox',
                            multiline: false,
                            value: val.btn_menu_value,
                            name: val.param_name,
                            label: val.heading
                        });


                  } else if (val.type == 'exploded_textarea') {

                    exploded_textarea_params.push(val.param_name) // add it to the array converted fields parameter

                        body.push({
                            type: 'textbox',
                            multiline: true,
                            minHeight: 100,
                            value: val.btn_menu_value,
                            name: val.param_name,
                            label: val.heading
                        });


                  } else if (val.type == 'dropdown_posts') {

                        body.push({
                            type: 'textbox',
                            multiline: false,
                            name: val.param_name,
                            label: val.heading + '(only IDs, comma-separated)'
                        });


                  } else if (val.type == 'posttypes') {


                        // Get post types information
                        var posttypes = jQuery.parseJSON(plethora_shortcode.posttypes);                        
                        var posttypes_val = '';
                        var c = 0;
                        jQuery.each(posttypes, function (option_key, option_val) {
                            c = c + 1;
                            if (c==1) { 
                                posttypes_val = posttypes_val + option_val;
                            } else {
                                posttypes_val = posttypes_val + ','+ option_val;
                            }
                        });

                        body.push({
                            type: 'textbox',
                            multiline: false,
                            value: posttypes_val,
                            name: val.param_name,
                            label: val.heading
                        });


                  } else if (val.type == 'widgetised_sidebars') {

                        // Get registered sidebars information
                         var sidebars = jQuery.parseJSON(plethora_shortcode.sidebars);    

                       // get select options in a variable
                        var options_select = [];
                        var c = 0;
                        var onPostRenderValue = '';
                        var selectedFirstValue = '';
                        jQuery.each(sidebars, function (sidebar_key, sidebar_name) {
                            options_select.push({
                                text: sidebar_name,
                                value: sidebar_key,
                            });
                            c = c + 1;
                            if ( c==1 ) { selectedFirstValue = sidebar_key; } // if no value is preselected, then auto select first value ( otherwise no selection inserted in editor if the control is not touched!)

                        });
                        // get default selected option in a variable
                        if ( typeof val.btn_menu_value !== 'undefined' && val.btn_menu_value !== '' ) { 

                           var onPostRenderValue = val.btn_menu_value;

                        } else { 

                           var onPostRenderValue = selectedFirstValue;

                        }

                        body.push({
                            type: 'listbox',
                            name: val.param_name,
                            label: val.heading,
                            'values': options_select,
                            onPostRender: function() { this.value(onPostRenderValue); }
                        });
    
                  } else if (val.type == 'textarea_raw_html') {

                        raw_html_params.push(val.param_name) // add it to the Base64 encoding parameter fields
                        body.push({
                            type: 'textbox',
                            multiline: true,
                            minHeight: 100,
                            value: val.btn_menu_value,
                            name: val.param_name,
                            label: val.heading
                        });
                  }

                    attr.push(sc_slug);
                });
            }

            //Listbox-Element (json)
            var list_el = {};

            //Listbox-Element Text
            list_el.text = sc_name;

            //Listbox-Element Value
            list_el.value = sc_slug;

            //Listbox-Element Action
            list_el.onclick = function (e) {
                editor.windowManager.open({
                    title: list_el.text,
                    body: body,
                    width: 600,
                    height: 450,
                    style: 'overflow:auto; overflow-x: hidden; border-radius:5px;',
                    onsubmit: function (e) {
                        var shortcode = '[' + list_el.value;

                        if (params) {
                            show_content = false;
                            theContent = '';
                            jQuery.each(e.data, function (key, val) {

                                // Check if this is THE content field (should be only one). If it is so, then wake up closing tag and keep content for inner
                                if (key != 'content' && key != 'description' && key != 'label' ) {

                                    // Check if this field contains a raw content value to encode
                                    var raw_html_param = raw_html_params.indexOf(key); 
                                    if ( raw_html_param != -1 ) { 

                                        //create the Base65 object
                                        var Base64={_keyStr:"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",encode:function(e){var t="";var n,r,i,s,o,u,a;var f=0;e=Base64._utf8_encode(e);while(f<e.length){n=e.charCodeAt(f++);r=e.charCodeAt(f++);i=e.charCodeAt(f++);s=n>>2;o=(n&3)<<4|r>>4;u=(r&15)<<2|i>>6;a=i&63;if(isNaN(r)){u=a=64}else if(isNaN(i)){a=64}t=t+this._keyStr.charAt(s)+this._keyStr.charAt(o)+this._keyStr.charAt(u)+this._keyStr.charAt(a)}return t},decode:function(e){var t="";var n,r,i;var s,o,u,a;var f=0;e=e.replace(/[^A-Za-z0-9\+\/\=]/g,"");while(f<e.length){s=this._keyStr.indexOf(e.charAt(f++));o=this._keyStr.indexOf(e.charAt(f++));u=this._keyStr.indexOf(e.charAt(f++));a=this._keyStr.indexOf(e.charAt(f++));n=s<<2|o>>4;r=(o&15)<<4|u>>2;i=(u&3)<<6|a;t=t+String.fromCharCode(n);if(u!=64){t=t+String.fromCharCode(r)}if(a!=64){t=t+String.fromCharCode(i)}}t=Base64._utf8_decode(t);return t},_utf8_encode:function(e){e=e.replace(/\r\n/g,"\n");var t="";for(var n=0;n<e.length;n++){var r=e.charCodeAt(n);if(r<128){t+=String.fromCharCode(r)}else if(r>127&&r<2048){t+=String.fromCharCode(r>>6|192);t+=String.fromCharCode(r&63|128)}else{t+=String.fromCharCode(r>>12|224);t+=String.fromCharCode(r>>6&63|128);t+=String.fromCharCode(r&63|128)}}return t},_utf8_decode:function(e){var t="";var n=0;var r=c1=c2=0;while(n<e.length){r=e.charCodeAt(n);if(r<128){t+=String.fromCharCode(r);n++}else if(r>191&&r<224){c2=e.charCodeAt(n+1);t+=String.fromCharCode((r&31)<<6|c2&63);n+=2}else{c2=e.charCodeAt(n+1);c3=e.charCodeAt(n+2);t+=String.fromCharCode((r&15)<<12|(c2&63)<<6|c3&63);n+=3}}return t}}
                                        //convert value
                                        var val = Base64.encode(val);
                                    }

                                    // Check if this field contains an exploded textarea to implode
                                    var exploded_textarea_param = exploded_textarea_params.indexOf(key); 
                                    if ( exploded_textarea_param != -1 ) { 

                                        var val_final = '';
                                        var val_array = val;
                                        var c = 0;

                                        //Split the lines in array
                                        val_res = val_array.replace( /\n/g, "|" );
                                        val_res = val_res.split( "|" );

                                        //Prepare final value;
                                        jQuery.each(val_res, function (exp_key, exp_val) {
                                            c = c + 1;
                                            if (c == 1) { 

                                                val_final = exp_val;

                                            } else {

                                                val_final = val_final +',' + exp_val;
                                            }
                                            
                                        });
                                        // replace the processed values
                                        val = val_final;
                                    }

                                    shortcode += ' ' + key + '="' + val + '"';

                                } else if (key == 'content' && key != 'description' && key != 'label' ) { 

                                    show_content = true;
                                    theContent = val;
                                
                                }


                            });
                        }


                        shortcode += ']';

                        if (show_content == true) {
                            shortcode += theContent;
                            shortcode += '[/' + list_el.value + ']';
                        }

                        editor.insertContent(shortcode);
                    }
                });
            };

            values.push(list_el);
        });


        return values;
    }

    tinymce.PluginManager.add('plethora_shortcodes_button', function (editor, url) {


        var values = getValues(editor);


        editor.addButton('plethora_shortcodes_button', {
            title: 'Plethora Shortcodes',
            icon: 'icon plethora-icon',
            type: 'menubutton',
            menu: values,
        });
    });


});