<?php
/*
 ______ _____   _______ _______ _______ _______ ______ _______ 
|   __ \     |_|    ___|_     _|   |   |       |   __ \   _   |
|    __/       |    ___| |   | |       |   -   |      <       |
|___|  |_______|_______| |___| |___|___|_______|___|__|___|___|

P L E T H O R A T H E M E S . C O M 				   (c) 2013

File Description: Controller class for shortcodes

*/

if ( ! defined( 'ABSPATH' ) ) exit; // NO DIRECT ACCESS 


if ( !class_exists('Plethora_Shortcode')) {
 
	/**
	 * @package Plethora Base
	 */

	class Plethora_Shortcode {

	    // Shortcode class
	    public $shortcode_slug; 

	    // Shortcode content function name
	    public $shortcode_content;

	    // Shortcode related script files
	    public $shortcode_scripts;
	 
	    // Shortcode localized script files
	    public $shortcode_localized_scripts;

	    // Shortcode related style files
	    public $shortcode_styles;

	    // Dynamic scripts switch value. It is checked inside HTML output. If set to true, it triggers script printing in footer
	    public $add_script;

   	  	
        /** 
        * Initializes Shortcode controller customization
        *
        * @since 1.0
        *
        */
   	  	public function init() {

		////// TINYMCE BUTTON EXTENSION
   	  		
   // 	  		if ( is_admin() ) { 

	  //  			// Add Plethora Panel Button
			// 	Plethora_Helper::add_action( 'admin_head', array( 'Plethora_Shortcode', 'fixpanel' ));
			// }


		////// VISUAL COMPOSER CUSTOMIZATION

			// set VC to behave as installed on theme
			if( function_exists('vc_set_as_theme') ) {

			    vc_set_as_theme( true );
			
			}
			// disable frontend editor
			if( function_exists( 'vc_disable_frontend' ) ) {

			    vc_disable_frontend( true );

			}

			if( function_exists( 'vc_map' ) ) {

			    add_action( 'admin_print_scripts-post.php', array( 'Plethora_Shortcode', 'custom_vc_enqueues' ));
			    add_action( 'admin_print_scripts-post-new.php', array( 'Plethora_Shortcode', 'custom_vc_enqueues' ));

			}

			// remove VC shortcodes that we don't apply on our themes
			if ( function_exists( 'vc_remove_element' )) {

			    // VC shortcodes
			    vc_remove_element( 'vc_accordion' );
			    vc_remove_element( 'vc_accordion_tab' );
			    vc_remove_element( 'vc_button' );
			    vc_remove_element( 'vc_button2' );
			    vc_remove_element( 'vc_carousel' );
			    // vc_remove_element( 'vc_column_text' );
			    vc_remove_element( 'vc_cta_button' );
			    vc_remove_element( 'vc_cta_button2' );
			    // vc_remove_element( 'vc_facebook' );
			    vc_remove_element( 'vc_flickr' );
			    vc_remove_element( 'vc_gallery' );
			    vc_remove_element( 'vc_gmaps' );
			    // vc_remove_element( 'vc_googleplus' );
			    vc_remove_element( 'vc_images_carousel' );
			    // vc_remove_element( 'vc_message' );
			    // vc_remove_element( 'vc_pie' );
			    // vc_remove_element( 'vc_pinterest' );
			    vc_remove_element( 'vc_posts_grid' );
			    vc_remove_element( 'vc_posts_slider' );
			    vc_remove_element( 'vc_progress_bar' );
			    // vc_remove_element( 'vc_raw_html' );
			    // vc_remove_element( 'vc_raw_js' );
			    // vc_remove_element( 'vc_separator' );
			    // vc_remove_element( 'vc_single_image' );
			    vc_remove_element( 'vc_tab' );
			    vc_remove_element( 'vc_tabs' );
			    vc_remove_element( 'vc_teaser_grid' );
			    // vc_remove_element( 'vc_text_separator' );
			    vc_remove_element( 'vc_toggle' );
			    vc_remove_element( 'vc_tour' );
			    // vc_remove_element( 'vc_twitter' );
			    // vc_remove_element( 'vc_tweetmeme' );
			    // vc_remove_element( 'vc_video' );
			    // vc_remove_element( 'vc_widget_sidebar' );
			    // WP shortcodes by VC
			    // vc_remove_element( 'vc_wp_archives' );
			    // vc_remove_element( 'vc_wp_calendar' );
			    // vc_remove_element( 'vc_wp_categories' );
			    // vc_remove_element( 'vc_wp_custommenu' );
			    // vc_remove_element( 'vc_wp_links' );
			    // vc_remove_element( 'vc_wp_meta' );
			    // vc_remove_element( 'vc_wp_posts' );
			    // vc_remove_element( 'vc_wp_recentcomments' );
			    // vc_remove_element( 'vc_wp_pages' );
			    // vc_remove_element( 'vc_wp_rss' );
			    // vc_remove_element( 'vc_wp_tagcloud' );
			    // vc_remove_element( 'vc_wp_text' );
			    // vc_remove_element( 'vc_wp_search' );
			    // Third party 
			    // vc_remove_element( 'contact-form-7' );
			    // vc_remove_element( 'gravityform' );
			    // vc_remove_element( 'layerslider_vc' );
			    // vc_remove_element( 'rev_slider_vc' );

			    // Update to 4.3.4 Shortcodes
			    vc_remove_element( 'vc_custom_heading' );
			    add_filter( 'vc_load_default_templates', array( 'Plethora_Shortcode', 'remove_default_templates' )); // remove VC default templates
			

			}

			// add custom VC fields
   	  		if ( is_admin() ) { 

				// Add the icon dropdown field function, via add_shortcode_param
			    $this->add_shortcode_param( 'dropdown_posts', array( 'Plethora_Shortcode', 'vc_field_select_posts'), '');

				// // Icon dropwdown start, via add_shortcode_param
			 //    $this->add_shortcode_param( 'dropdown_icons', array( 'Plethora_Shortcode', 'vc_field_select_icons'), THEME_CORE_ASSETS_URI . '/vcfields/dropdown_icons/bootstrap-iconpicker.min.js');
		 
			 // 	// Add new fields styles
			 //    $this->add_vc_style( array(
			 //    	    array( 
				// 	    'handle'    => 'wpb_bootstrap_fontawesome', 
				// 	    'src'       => THEME_CORE_ASSETS_URI . '/font-awesome/css/font-awesome.min.css', 
				// 	    'deps'      => array(),
				// 	    'ver'       => '1.0', 
				// 	    'media' 	=> 'all'
				// 	    ),
			 //    		array( 
				// 	    'handle'    => 'wpb_bootstrap_iconpicker', 
				// 	    'src'       => THEME_CORE_ASSETS_URI . '/vcfields/dropdown_icons/bootstrap-iconpicker.min.css', 
				// 	    'deps'      => array(),
				// 	    'ver'       => '1.0', 
				// 	    'media' 	=> 'all'
				// 		), 
				// ));

			}

			// Regenarate shortcode parameters option (important!)
   	  		if ( is_admin() ) { 

				// Get saved parameters
				$update = update_option(PLETHORA_PREFIX .'_shortcode_params', array());
			}	
			
  		}

        /** 
        * Add shortcode action
        *
        * @since 1.0
        *
        */
        public function add( $tag, $func ) {

            $this->shortcode_slug = $tag;
            add_shortcode( $tag, $func );

        }


        /** 
        * Mapping shortcode parameters for shortcode panel ( TinyMCE ). Actually it saves the settings in a WP option for later use.
        *
        * @since 1.0
        *
        */

		public function map_panel( $params ) {
		
			if ( !isset($params) || empty($params) || !is_array($params) ) { return; }
		      
		      // Get saved parameters
		      $saved_params = get_option( PLETHORA_PREFIX .'_shortcode_params', array());
			  
		      // Check if shortcode already mapped

		          //Class index ---> record array
		          $saved_params[$this->shortcode_slug] = array($params);
			      $update = update_option(PLETHORA_PREFIX .'_shortcode_params', $saved_params );

	     }


	    /**
         * Shortcode script actions
	     *
	     * @since 1.0
	     *
	     */

       public function add_script( $scripts ) {

			// Assign $scripts to shortocode_scripts variable
			$this->shortcode_scripts = $scripts; 
			
			// Add script registration hooks
			Plethora_Helper::add_action( 'init', array( $this, 'register_script' ));
            Plethora_Helper::add_action( 'wp_footer', array( $this, 'print_script'));
       }		

	    /**
         * Shortcode script registrations
	     *
	     * @since 1.0
	     *
	     */

       public function register_script() {

			// Get scripts parameters
			$scripts = $this->shortcode_scripts;

			if (is_array($scripts)) { 

				foreach ($scripts as $script) { 

					// Make sure that required parameters are ok
					if (( isset($script['handle']) && !empty($script['handle'] ))) { 

						if ( isset($script['src']) && !empty($script['src'] ) ){

							// Fixing parameters for wp_register_script ( https://codex.wordpress.org/Function_Reference/wp_register_script )
							$handle 	= $script['handle']; 
							$src 		= $script['src']; 
							$deps 		= ( !isset( $script['deps'] ) || !is_array( $script['deps'] )) ? array() : $script['deps'];
							$ver 		= ( !isset( $script['ver'] ) || !is_string( $script['ver'] )) ? false : $script['ver'] ;
							$in_footer 	= ( !isset( $script['in_footer'] ) || !is_bool( $script['in_footer'] )) ? false : $script['in_footer'] ;

							//Register script
			        		wp_register_script( $handle, $src, $deps, $ver, $in_footer );

						} elseif ( isset( $script['type'] ) && $script['type'] === 'localized_script' ){

							$handle   = $script['handle']; 
							$variable = $script['variable']; 
							$data     = ( !isset( $script['data'] ) || !is_array( $script['data'] )) ? array() : $script['data'];

							//Localize script
							wp_localize_script( $handle, $variable, $data );        

						} 


		        	}
		        }
        	}
       }

	    /**
         * Shortcode scripts dynamic output. Scripts are printed only when the shortcode is active
	     *
	     * @since 1.0
	     *
	     */

       public function print_script() {

			// Get scripts parameters
			$scripts = $this->shortcode_scripts;

			if (is_array($scripts)) { 

				foreach ($scripts as $script) { 

					// Make sure that required parameters are ok
					if (( isset($script['handle']) && !empty($script['handle'] )) && ($this->add_script )) { 

						// Fixing parameters for wp_print_scripts ( https://codex.wordpress.org/Plugin_API/Action_Reference/wp_print_scripts )
						$handle 	= $script['handle']; 

						//Register script
		        		wp_print_scripts( $handle );
		        	}
		        }
        	}
       }


	    /**
         * Shortcode style action
	     *
	     * @since 1.0
	     *
	     */

       public function add_style( $style ) {

			// assign $scripts to shortocode_style variable
			$this->shortcode_styles = $style; 
			
			// Add style registration hooks
			Plethora_Helper::add_action( 'init', array( $this, 'register_style' ));
       }		


	    /**
         * Shortcode styles registration
	     *
	     * @since 1.0
	     *
	     */

       public function register_style() {

			$styles = $this->shortcode_styles;

			if (is_array($styles)) { 

				foreach ($styles as $style) { 

					if (( isset($style['handle']) && !empty($style['handle'] )) && (isset($style['src']) && !empty($style['src'] ))) { 

						// Fixing parameters for wp_register_style ( http://codex.wordpress.org/Function_Reference/wp_register_style )
						$handle = $style['handle']; 
						$src	= $style['src']; 
						$deps	= ( !isset( $style['deps'] ) || !is_array( $style['deps'] )) ? array() : $style['deps'];
						$ver	= ( !isset( $style['ver'] ) || !is_string( $style['ver'] )) ? false : $style['ver'] ;
						$media 	= ( !isset( $style['media'] ) || !is_string( $style['media'] )) ? 'all' : $style['media'] ;

						// Register style
		        		wp_register_style ( $handle, $src, $deps, $ver, $media );

						// Enqueue style
		         		wp_enqueue_style  ( $handle );
		        	}
		        }
			}
       }


	    /**
	     * Adds the Shortcodes Panel to TinyMCE editor
	     *
	     * @since 1.0
	     *
	     */
	     public static function fixpanel() { 
    		
    		// Check if page is a post edit page
			if( !Plethora_Helper::is_edit_page() )
		        return;

    		// Check if post edit page with editor
    		global $typenow;
			if( ! in_array( $typenow, Plethora_Helper::array_posttypes_with_editor() ) )
		        return;

    		// Check if current user has the permission to edit post/pages and rich editing texts in order to proceed
		   if ( current_user_can('edit_posts') &&  current_user_can('edit_pages') && get_user_option('rich_editing') == 'true' ) {  

			// Enqueue js file for Plethora Button
			 wp_enqueue_script( 'plethora_shortcodes_button_script', THEME_CORE_LIBS_URI . '/shortcodes/tinymce-shortcodes-button.js', array( 'jquery' ) );
		
			// Prepare shortcode settings array (passed via wp_localize_script)
			     $shortcode_params = get_option( PLETHORA_PREFIX .'_shortcode_params', array());
			     $shortcode_params_json = array(); // prepare array that will be json encoded for proper later use in javascript function. This means removing keys from existing $shortcode_params array
			     foreach ($shortcode_params as $key=>$shortcode_param) { 

			     	$shortcode_params_json[] = $shortcode_param;
			     }
			     $shortcode_params_json = json_encode($shortcode_params_json);

			 // Prepare post types array for use with Post Types field (passed via wp_localize_script)
	    		$post_types = get_post_types();
			     foreach ($post_types as $key=>$post_type) { 
			     	if ($key != 'attachment' && $key != 'revision' && $key != 'nav_menu_item') { 
			     	$post_types_json[] = $post_type;
			     	}
			     }
			     $post_types_json = json_encode($post_types_json);

			 // Prepare widgetized area array for use with  widgetised_sidebars field (passed via wp_localize_script)
			    $sidebars = Plethora_Helper::array_widgetized_areas();
				$sidebars_json = json_encode($sidebars);


			// Send variables to javascript
				 $localize_variables = array(
				 						'params' => $shortcode_params_json, 
				 						'posttypes' => $post_types_json,
				 						'sidebars' => $sidebars_json
				 						);
				 wp_localize_script( 'plethora_shortcodes_button_script', 'plethora_shortcode', $localize_variables );	

		     // Hook related functions to Tinymce
		     Plethora_Helper::add_filter('mce_external_plugins', array( 'Plethora_Shortcode', 'load_panel_plugin' ));  
		     Plethora_Helper::add_filter('mce_buttons', array( 'Plethora_Shortcode', 'register_panel_button' ), 98); 
		   }  
	     }

	    /**
	     * Returns the Shortcodes Panel plugin settings for TinyMCE editor 
	     *
	     * @since 1.0
	     *
	     */
		public static function load_panel_plugin( $plugins ) { 

		   	$plugins['plethora_shortcodes_button'] = THEME_CORE_LIBS_URI . '/shortcodes/tinymce-shortcodes-button.js';
		   	return $plugins;
		
		} 
	
	    /**
	     * Registers the 'Plethora Shortcodes' button to TinyMCE editor
	     *
	     * @since 1.0
	     *
	     */
		public static function register_panel_button( $buttons ) { 

		   array_push($buttons, "plethora_shortcodes_button");
		   return $buttons;
		
		}


	    /**
	     * Add shortcode parameter method ( extends Visual Composer parameters ).
	     *
	     * @since 1.0
	     *
	     */
		function add_shortcode_param( $name, $callback_function, $js = '') {

			if ( function_exists('add_shortcode_param') ) { 

				if ( empty($js) ) { 

					add_shortcode_param( $name, $callback_function );

				} else { 
					add_shortcode_param( $name, $callback_function, $js );

				}
			}
		}

///// Visual Composer by Plethora



		public static function remove_default_templates( $data ) {

			    return array(); // This will remove all default templates

		}

	    /**
        * Mapping shortcode parameters for Visual Composer Panel
	     *
	     * @since 1.0
	     *
	     */
        public static function custom_vc_enqueues() {

			// First, on which post types VC is applied
			$post_types = get_option( 'wpb_js_content_types', array( 'page' ) );
        	
			// Apply the script/style on specific post types
        	if( $post_types ==! null ) {
        		
        		if( in_array( get_post_type(), $post_types ) ) {

		            wp_enqueue_style(  'plethora-vc-admin', THEME_CORE_ASSETS_URI . '/visual-composer/vc_custom.css', array( 'js_composer' ) );
		            wp_enqueue_script( 'plethora-vc-admin', THEME_CORE_ASSETS_URI . '/visual-composer/vc_custom.js',  array( 'wpb_js_composer_js_view' ), PLETHORA_VERSION, true);
			
		        }
			}	            
		}


	    /**
        * Mapping shortcode parameters for Visual Composer Panel
	     *
	     * @since 1.0
	     *
	     */
        public function map_vcpanel( $params = array() ) {

			if ( !isset($params) || empty($params) || !is_array($params) ) { return; }

		    if ( function_exists( 'vc_map' )) { 

	            vc_map( $params );
	        }
		}


	    /**
         * Shortcode script actions only for Visual Composer integration
	     *
	     * @since 1.0
	     *
	     */

        public function add_vc_script( $script ) {

			if ( function_exists('add_shortcode_param') ) { 
				// Assign $scripts to shortocode_scripts variable
				$this->shortcode_scripts = $script; 

				// Add script registration hooks
				Plethora_Helper::add_action( 'admin_enqueue_scripts', array( $this, 'load_vc_script' ));
 
       		}
        }		

	    /**
         * Shortcode script registrations, only for Visual Composer integration
	     *
	     * @since 1.0
	     *
	     */

	    public function load_vc_script() {

			if ( function_exists('add_shortcode_param') ) { 
				// Get script parameters
				$scripts = $this->shortcode_scripts;

				if (is_array($scripts)) { 

					foreach ($scripts as $script) { 

						// Make sure that required parameters are ok
						if (( isset($script['handle']) && !empty($script['handle'] )) && (isset($script['src']) && !empty($script['src'] ))) { 

							// Fixing parameters for wp_register_script ( https://codex.wordpress.org/Function_Reference/wp_register_script )
							$handle 	= $script['handle']; 
							$src 		= $script['src']; 
							$deps 		= ( !isset( $script['deps'] ) || !is_array( $script['deps'] )) ? array() : $script['deps'];
							$ver 		= ( !isset( $script['ver'] ) || !is_string( $script['ver'] )) ? false : $script['ver'] ;
							$in_footer 	= ( !isset( $script['in_footer'] ) || !is_bool( $script['in_footer'] )) ? false : $script['in_footer'] ;

							//Register script
			        		wp_register_script( $handle, $src, $deps, $ver, $in_footer );
						    wp_enqueue_script ( $handle );
			        	}
			        }
			    }
       		}
	    }

	    /**
         * Shortcode style actions only for Visual Composer integration
	     *
	     * @since 1.0
	     *
	     */

        public function add_vc_style( $style ) {

			if ( function_exists('add_shortcode_param') ) { 
				// Assign $scripts to shortocode_scripts variable
				$this->shortcode_styles = $style; 

				// Add script registration hooks
				Plethora_Helper::add_action( 'admin_print_styles', array( $this, 'load_vc_style' ));

       		}
        }		


	    /**
         * Shortcode script registrations, only for Visual Composer integration
	     *
	     * @since 1.0
	     *
	     */

	    public function load_vc_style() {

			if ( function_exists('add_shortcode_param') ) { 
				// Get style parameters
				$styles = $this->shortcode_styles;

				if (is_array($styles)) { 

					foreach ( $styles as $style ) { 
						// Make sure that required parameters are ok
						if (( isset($style['handle']) && !empty($style['handle'] )) && (isset($style['src']) && !empty($style['src'] ))) { 

							// Fixing parameters for wp_register_script ( https://codex.wordpress.org/Function_Reference/wp_register_script )
							$handle 	= $style['handle']; 
							$src 		= $style['src']; 
							$deps 		= ( !isset( $style['deps'] ) || !is_array( $style['deps'] )) ? array() : $style['deps'];
							$ver 		= ( !isset( $style['ver'] ) || !is_string( $style['ver'] )) ? false : $style['ver'] ;
							$media 		= ( !isset( $style['media'] ) || !is_string( $style['media'] )) ? 'all' : $style['media'] ;

							//Register script
			        		wp_register_style( $handle, $src, $deps, $ver, $media );
						    wp_enqueue_style  ( $handle );
			        	}
			        }
	        	}
       		}
	    }

		static function vc_field_select_icons( $settings, $value) {

		   $dependency = vc_generate_dependencies_attributes($settings);

		   $return  = '<div class="'.$settings['param_name'].'_block">'. "\n";
		   $return .= '<button type="button" data-inputname="'.$settings['param_name'].'" data-icon="'. $value .'" class="btn btn-default" data-iconset="fontawesome" role="iconpicker" data-rows="3" data-cols="10"></button>'. "\n";
		   $return .= '<input name="'.$settings['param_name'].'" id="'.$settings['param_name'].'" class="wpb_vc_param_value '.$settings['param_name'].' '.$settings['type'].'" type="hidden" value="'.$value.'" ' . $dependency . '/>';
		   $return .= '</div>'. "\n";
         
           return $return;
		}

		static function vc_field_select_posts( $settings, $value) {

		   $dependency = vc_generate_dependencies_attributes($settings);
		   $post_type  = (isset($settings['type_posts']) && !empty($settings['type_posts'])) ? $settings['type_posts'] : array('post') ;

		   $return  = '<div class="'.$settings['param_name'].'_block">'. "\n";
		   
		   $return .= '<script language="JavaScript" type="text/javascript">'. "\n";
		   $return .= 'function loopSelected_'. $settings['param_name'] .'()'. "\n";
		   $return .= '{'. "\n";
		   $return .= '  var txtSelectedValuesObj = document.getElementById("'. $settings['param_name'] .'");'. "\n";
		   $return .= '  var selectedArray = new Array();'. "\n";
		   $return .= '  var selObj = document.getElementById("'. $settings['param_name'] .'_select");'. "\n";
		   $return .= '  var i;'. "\n";
		   $return .= '  var count = 0;'. "\n";
		   $return .= '  for (i=0; i<selObj.options.length; i++) {'. "\n";
		   $return .= '    if (selObj.options[i].selected) {'. "\n";
		   $return .= '      selectedArray[count] = selObj.options[i].value;'. "\n";
		   $return .= '      count++;'. "\n";
		   $return .= '    }'. "\n";
		   $return .= '  }'. "\n";
		   $return .= '  txtSelectedValuesObj.value = selectedArray;'. "\n";
		   $return .= '}'. "\n";
		   $return .= '</script>'. "\n";

		   $return  .= '<select multiple id="'. $settings['param_name'] .'_select" onchange="loopSelected_'. $settings['param_name'] .'();"  ' . $dependency . '>';
					
		 		    // Set selected values array from saved string
		 		    $sel_value = ( is_string($value) ) ? explode (',', $value) : $value;

					$args = array( 

						'posts_per_page'   => -1,
						'orderby'          => 'post_date',
						'order'            => 'DESC',
						'post_type'        => $post_type,
						'post_status'      => 'publish',

						);
					$posts = get_posts( $args );

					foreach ($posts as $post) { 

							if ( is_array($sel_value) && in_array($post->ID, $sel_value) ) { 

								$selected = ' selected="selected"';
								
							} elseif (!is_array($sel_value) && $sel_value == $post->ID) { 

								$selected = ' selected="selected"';

							} else {

								$selected = '';

							}

							$return  .= '<option value="'. $post->ID .'"'. $selected .'>'. $post->post_title .'</option>'. "\n";

					}           
		   $return .= '</select>'. "\n";
		   $return .= '<input name="'.$settings['param_name'].'" id="'.$settings['param_name'].'" class="wpb_vc_param_value '.$settings['param_name'].' '.$settings['type'].'" type="hidden" value="'. $value .'"/>';
		  

		   $return .= '</div>'. "\n";



          return $return;
		}

	    /**
         * Handles Visual Composer's vc_build_link, in case VC is not installed
	     *
	     * @since 1.0
	     *
	     */

		static function vc_build_link( $string ) {

			if ( function_exists('vc_build_link')) { 

            	$link = vc_build_link( $string );

			} else { 

	            $array = explode('|', $string);
	            $link['url'] 	= ( isset($array[0]) && !empty($array[0]) ) ? rawurldecode(substr($array[0], 4)) : '';
	            $link['title'] 	= ( isset($array[1]) && !empty($array[1]) ) ? rawurldecode(substr($array[1], 6)) : '';
	            $link['target'] = ( isset($array[2]) && !empty($array[2]) ) ? rawurldecode( substr($array[2], 7)) : '';
			}
			
			return $link;

		}


	}



    // Initialize class
    if ( class_exists( 'Plethora_Shortcode' ) ) { 

        $shortcodes = new Plethora_Shortcode;
        $shortcodes->init();

    }

	
 }